//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#ifndef _C_OBJECT_
#define _C_OBJECT_
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CObject
  {
private:
   CObject          *cPrevIterator;
   CObject          *cNextIterator;
public:
                     CObject(void):cPrevIterator(NULL),cNextIterator(NULL) {}
                    ~CObject(void);
   CObject*          GetNextIterator() {return cNextIterator;}
   CObject*          GetPrevIterator() {return cPrevIterator;}
   void              SetIteratorNext(CObject* mObj)   {cNextIterator=mObj;}
   void              SetIteratorPrev(CObject* mObj)   {cPrevIterator=mObj;}
   void              ResetObjIterators() {cNextIterator=cPrevIterator=NULL;}
  };
//-----------------------------------------------------
CObject::~CObject(void)
  {
   if(CheckPointer(cPrevIterator)) cPrevIterator.SetIteratorNext(cNextIterator);
   if(CheckPointer(cNextIterator)) cNextIterator.SetIteratorPrev(cPrevIterator);
  }

#endif 
//+------------------------------------------------------------------+
